#include<bits/stdc++.h>
using namespace std;
#define MAXN 20005
#define ll long long
vector<pair<string,int>>v;
vector<vector<int>>ras(MAXN);
int solve(int O, int A, int B, int AB, int n)
{
    for(int i=0;i<n;i++)
    {
        if(v[i].first=="O")
        {
            if(O>=v[i].second)
            {
                ras[i]={v[i].second,0,0,0};
                O-=v[i].second;
            }
            else
            {
                cout<<"nemoguce"<<endl;
                return 0;
            }
        }
    }
    for(int i=0;i<n;i++)
    {
        if(v[i].first=="A")
        {
            int cnt=0;
            int a=0;
            while(A!=0 && cnt!=v[i].second)
            {
                A--;
                cnt++;
            }
            a=cnt;
            while(O!=0 && cnt!=v[i].second)
            {
                O--;
                cnt++;
            }
            ras[i]={cnt-a,a,0,0};
            if(cnt!=v[i].second)
            {
                cout<<"nemoguce"<<endl;
                return 0;
            }
        }
    }
    for(int i=0;i<n;i++)
    {
        if(v[i].first=="B")
        {
            int cnt=0;
            int a=0;
            while(B!=0 && cnt!=v[i].second)
            {
                B--;
                cnt++;
            }
            a=cnt;
            while(O!=0 && cnt!=v[i].second)
            {
                O--;
                cnt++;
            }
            ras[i]={cnt-a,0,a,0};
            if(cnt!=v[i].second)
            {
                cout<<"nemoguce"<<endl;
                return 0;
            }
        }
    }
    for(int i=0;i<n;i++)
    {
        if(v[i].first=="AB")
        {
            int cnt=0;
            ras[i]={0,0,0,0};
            while(O>0 && cnt!=v[i].second)
            {
                O--;
                cnt++;
                ras[i][0]++;
            }
            while(A>0 && cnt!=v[i].second)
            {
                A--;
                cnt++;
                ras[i][1]++;
            }
            while(B>0 && cnt!=v[i].second)
            {
                B--;
                cnt++;
                ras[i][2]++;
            }
            while(AB>0 && cnt!=v[i].second)
            {
                AB--;
                cnt++;
                ras[i][3]++;
            }
            if(cnt!=v[i].second)
            {
                cout<<"nemoguce"<<endl;
                return 0;
            }
        }
    }
    cout<<"moguce"<<endl;
    for(int i=0;i<n;i++)
    {
        cout<<ras[i][0]<<" "<<ras[i][1]<<" "<<ras[i][2]<<" "<<ras[i][3]<<endl;
    }
    return 0;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    int n;
    int O,A,B,AB;
    cin>>n;
    cin>>O>>A>>B>>AB;
    string s;
    int a;
    for(int i=0;i<n;i++)
    {
        cin>>s>>a;
        v.emplace_back(s,a);
    }
    solve(O,A,B,AB,n);
}